%
% Vytvorenie struktury "bg", staticke objekty obrazku
% Tatiana Lipnicanova
% marec 2004
%
function bg = background
global intr bg

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% IT'S POSSIBLE TO CHANGE
% the dimension of tanks approximately +50/-100
movement_x = 180;       % width
movement_y = 250;       % higth
% width of pipeline
p_width = 28;
% positions of tanks without and with interaction
M_x = [250 500 200 600];     % in the direct of x-axis
M_y = [700 -350 400 0];      % in the direct of y-axis
% editing of the higth of left pipeline
ky = 50;
% editing of the end of right pipeline / the y-axes of end point/
pr_end = 100;
% sometimes it is necessary to change konstankts (kmr,kl) in front of p_width
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

bottom_tank = [17.5 62.5 62.5 62.5 1437.5 1437.5 1437.5 1482.5 1477.5 1462.5 1462.5 37.5 37.5 22.5 17.5; ...
      225 217.5 180 25 25 180 217.5 225 187.5 180 0 0 180 187.5 225]';
bottom_part1 =[ 11 19 24 30 40 50 67 74 88 114 150; ...
      12 10 9 8 8 7 6 6 5 5 4]';
s_b = size(bottom_part1);
bottom_part2 = zeros(s_b);
bottom_part3 = zeros(s_b);
bottom_part4 = zeros(s_b);

roof_part1 =[ 11 30 45 62 78 90 94 104 115 122 130 140 152; ...
      (movement_y * ones(1,13)+ [12 20 24 28 30 32 32 33 33.5 34.5 35 36 36]) ]';
s_r = size(roof_part1);
roof_part2 = zeros(s_r);

k = s_b(1);
bottom_part2(1,1) = bottom_part1(s_b(1),1) + movement_x;
bottom_part2(k,2) = bottom_part1(1,2);
bottom_part3(1,:) = bottom_part1(1,:);

for i = 2 : s_b(1),
   bottom_part2(i,1) = bottom_part2(i-1)+(bottom_part1((s_b(1)-(i-2)),1)-bottom_part1((s_b(1)-(i-2)-1),1));
   bottom_part2((i-1),2) = bottom_part1(k,2);
   
   bottom_part3(i,2) = bottom_part3((i-1),2)+(bottom_part1((i-1),2)-bottom_part1(i,2));
   bottom_part3(i,1) = bottom_part1(i,1);
   
   k = k - 1;
end

k = s_b(1);
bottom_part4(k,:) = bottom_part2(k,:);
for i = 2 : s_b(1),
   bottom_part4((k-1),2) = bottom_part4(k,2)+(bottom_part2(k,2)-bottom_part2((k-1),2));
   bottom_part4((k-1),1) = bottom_part2((k-1),1);
   k = k - 1;
end

top_part1 = [( bottom_part1(:,1))'; ...
      (movement_y*ones(s_b(1),1)+ bottom_part1(:,2))']';
top_part2 = [( bottom_part2(:,1))'; ...
      (movement_y*ones(s_b(1),1)+ bottom_part2(:,2))']';
top_part3 = [( bottom_part3(:,1))'; ...
      (movement_y*ones(s_b(1),1)+ bottom_part3(:,2))']';
top_part4 = [( bottom_part4(:,1))'; ...
      (movement_y*ones(s_b(1),1)+ bottom_part4(:,2))']';
s_t = size(top_part1);

down_1 = [bottom_part1(s_b(1),1) bottom_part2(1,1); ...
      bottom_part1(s_b(1),2) bottom_part2(1,2)]';
down_2 = [bottom_part3(s_b(1),1) bottom_part4(1,1); ...
   bottom_part3(s_b(1),2) bottom_part4(1,2)]';
s_ud = size(down_1);

up_1 = [top_part1(s_b(1),1) top_part2(1,1); ...
      top_part1(s_b(1),2) top_part2(1,2)]';
up_2 = [top_part3(s_b(1),1) top_part4(1,1); ...
   top_part3(s_b(1),2) top_part4(1,2)]';

kx = 0.80*(movement_x-123);
ko = 0.15*ky;
out = [ kx+409 kx+407.6 kx+406.3 kx+406.3 kx+406.3 kx+407.5 kx+407.8 kx+409.2 kx+410.6; ...
      ko+12.8 ko+15.2 ko+18.8 ko+24.7 ko+28.3 ko+30.9 ko+33.2 ko+35.5 ko+36.6]';
s_i = size(out);

left_side = [bottom_part1(1,1) top_part1(1,1); ...
      bottom_part1(1,2) top_part1(1,2)]';
right_side = [bottom_part2(11,1) top_part2(11,1); ...
      out(s_i(1),2) top_part2(11,2)]';

s_lr = size(left_side);

roof_part2(1,:) = right_side(2,:);
for i = 2 : s_r(1),
   roof_part2(i,1) = roof_part2((i-1),1)+(roof_part1((i-1),1)-roof_part1(i,1));
   roof_part2(i,2) = roof_part1(i,2);
end
s_r12 = size(roof_part1);

semidiameter_inflow = (roof_part1(s_r(1),1)+roof_part2(s_r(1),1))/2;
roof_part3 = [ roof_part1(s_r(1),1) semidiameter_inflow-(p_width/2) semidiameter_inflow-(p_width/2) semidiameter_inflow+15 semidiameter_inflow+15 roof_part2(s_r(1),1); ...
   roof_part1(s_r(1),2) roof_part1(s_r(1),2) roof_part1(s_r(1),2)+13 roof_part2(s_r(1),2)+13 roof_part2(s_r(1),2) roof_part2(s_r(1),2)]';
s_r3 = size(roof_part3);

switch intr
    case 0
        % without interaction
        move_x =[M_x(1) M_x(2)];
        move_y =[M_y(1) M_y(2)];
    case 1
        % with interaction
        move_x =[M_x(3) M_x(4)];
        move_y =[M_y(3) M_y(4)];
end

i = 1;
for i = 1 : 2,
    bottom_part1 = bottom_part1 + [move_x(i)*ones(s_b(1),1) move_y(i)*ones(s_b(1),1)];
    bottom_part2 = bottom_part2 + [move_x(i)*ones(s_b(1),1) move_y(i)*ones(s_b(1),1)];
    bottom_part3 = bottom_part3 + [move_x(i)*ones(s_b(1),1) move_y(i)*ones(s_b(1),1)];
    bottom_part4 = bottom_part4 + [move_x(i)*ones(s_b(1),1) move_y(i)*ones(s_b(1),1)];
    top_part1 = top_part1 + [move_x(i)*ones(s_b(1),1) move_y(i)*ones(s_b(1),1)];
    top_part2 = top_part2 + [move_x(i)*ones(s_b(1),1) move_y(i)*ones(s_b(1),1)];
    top_part3 = top_part3 + [move_x(i)*ones(s_b(1),1) move_y(i)*ones(s_b(1),1)];
    top_part4 = top_part4 + [move_x(i)*ones(s_b(1),1) move_y(i)*ones(s_b(1),1)];
    down_1 = down_1 + [move_x(i)*ones(s_ud(1),1) move_y(i)*ones(s_ud(1),1)];
    down_2 = down_2 + [move_x(i)*ones(s_ud(1),1) move_y(i)*ones(s_ud(1),1)];
    up_1 = up_1 + [move_x(i)*ones(s_ud(1),1) move_y(i)*ones(s_ud(1),1)];
    up_2 = up_2 + [move_x(i)*ones(s_ud(1),1) move_y(i)*ones(s_ud(1),1)];
    left_side = left_side + [move_x(i)*ones(s_lr(1),1) move_y(i)*ones(s_lr(1),1)];
    right_side = right_side + [move_x(i)*ones(s_lr(1),1) move_y(i)*ones(s_lr(1),1)];
    roof_part1 = roof_part1 + [move_x(i)*ones(s_r12(1),1) move_y(i)*ones(s_r12(1),1)];
    roof_part2 = roof_part2 + [move_x(i)*ones(s_r12(1),1) move_y(i)*ones(s_r12(1),1)];
    roof_part3 = roof_part3 + [move_x(i)*ones(s_r3(1),1) move_y(i)*ones(s_r3(1),1)];
    out = out + [move_x(i)*ones(s_i(1),1) move_y(i)*ones(s_i(1),1)];
    
    if i == 1
        bottom_part11 = bottom_part1;
        bottom_part21 = bottom_part2;
        bottom_part31 = bottom_part3;
        bottom_part41 = bottom_part4;
        top_part11 = top_part1;
        top_part21 = top_part2;
        top_part31 = top_part3;
        top_part41 = top_part4;
        down_11 = down_1;
        down_21 = down_2;
        up_11 = up_1;
        up_21 = up_2;
        left_side1 = left_side;
        right_side1 = right_side;
        roof_part11 = roof_part1;
        roof_part21 = roof_part2;
        roof_part31 = roof_part3;
        out1 = out;
    end
end

if intr == 1
    roof_part3 = zeros(2,2);
    roof_part3 = [ roof_part1(s_r(1),1) roof_part2(s_r(1),1); ...
            roof_part1(s_r(1),2) roof_part2(s_r(1),2)]';
end

kx = 0.5*(movement_x-123);
px = [move_x(1)-200 move_x(2)-400];
% sometimes it is necessary to change konstankts in front of p_width
kl = 0.7;   % initial value = 1
kmr = 1;  % initial value = 1

if intr == 1
    ky = ky - 300;
end
pipeline_left1 = [ 98 98.5 100 101.5  103 103.5 px(1)+kx+418  px(1)+kx+423.5  px(1)+kx+424  px(1)+kx+425 px(1)+kx+425 roof_part31(4,1); ...
      65 ky+1000 ky+1009.7 ky+1019.1 ky+1024   ky+1025  ky+1025 ky+1018.5 ky+1011.7 ky+1007 ky+1005 roof_part31(4,2)]';

pipeline_left2 = [ (pipeline_left1(1:6,1)+ p_width*ones(6,1))' (pipeline_left1(7:11,1)- p_width*ones(5,1))' roof_part31(3,1); ...
      pipeline_left1(1,2) (pipeline_left1(2:11,2)- kl*p_width*ones(10,1))' roof_part31(3,2)]';

kk = [720 640 725 585];

switch intr
    case 0
        pipeline_m1 = [out1(s_i(1),1)  roof_part3(3,1) px(2)+(pipeline_left1(7:11,1)+ 403*ones(5,1))' roof_part3(4,1); ...
                out1(s_i(1),2) out1(s_i(1),2) ko+(pipeline_left1(7:11,2)- 290*ones(5,1))'-ky roof_part3(4,2)]';
        pipeline_m2 = [out1(s_i(1),1) (pipeline_m1(3:7,1) - p_width*ones(5,1))' roof_part3(3,1); ...
                out1(1,2) (pipeline_m1(3:7,2)- kmr*p_width*ones(5,1))' roof_part3(3,2)]';
        p_r1 = [out(s_i(1),1) px(2)+(pipeline_left1(7:11,1)+kk(1)*ones(5,1))'; ...
                out(s_i(1),2) (ko+(pipeline_left1(7:11,2)-kk(2)*ones(5,1))'-ky)];
    case 1
        pipeline_m1 = [out1(s_i(1),1) left_side(1,1); ...
                out1(s_i(1),2) out1(s_i(1),2)]';
        pipeline_m2 = [pipeline_m1(:,1)'; ...
                (pipeline_m1(:,2)-kmr*p_width*ones(2,1))']';
        p_r1 = [out(s_i(1),1) px(2)+(pipeline_left1(7:11,1)+kk(3)*ones(5,1))'; ...
                out(s_i(1),2) (ko+(pipeline_left1(7:11,2)-kk(4)*ones(5,1))'-ky)];
end
s_pm = size(pipeline_m1);

pipeline_right1 = [p_r1(1,:) p_r1(1,6); ...
        p_r1(2,:) p_r1(2,6)-pr_end]';
pipeline_right2 = [out(s_i(1),1) (pipeline_right1(2:7,1) - kmr*p_width*ones(6,1))'; ...
        out(1,2) (pipeline_right1(2:6,2)- kmr*p_width*ones(5,1))' pipeline_right1(7,2)]';

pump = [0 24 48 72 72 48 24 0 0; ...
      174 180 180 174 6 0 0 6 174]';
pump = [(pump(:,1) + 77*ones(9,1)) (pump(:,2) + 300*ones(9,1))];

% possition of a text which display the curent value of a flow and a water hight
if intr == 0
    X_t1 = [445 935];
    Y_t = [670 320];
    X_t2 = [290 780];

    X_t3 = [705 1205 1410];
    X_t4 = [535 1035 1235];
    
    Y_t3 = [1045 695 430];
elseif intr == 1
    X_t1 = [410 1000];
    Y_t = [360 360];
    X_t2 = [260 850];
    
    X_t3 = [305 790 1195];
    X_t4 = [130 610 1015];
    
    Y_t3 = [825 725 265];
end

bg = struct(...
   'bottom_tank', bottom_tank, ...
   'bottom_part1',bottom_part1, 'bottom_part11',bottom_part11, ...
   'bottom_part2',bottom_part2, 'bottom_part21',bottom_part21, ...
   'bottom_part4',bottom_part4, 'bottom_part41',bottom_part41, ...
   'top_part1',top_part1, 'top_part11',top_part11, ...
   'top_part2',top_part2, 'top_part21',top_part21, ...
   'top_part3',top_part3, 'top_part31',top_part31, ...
   'top_part4',top_part4, 'top_part41',top_part41, ...
   'left_side',left_side, 'left_side1',left_side1, ...
   'right_side',right_side, 'right_side1',right_side1, ...
   'bottom_part3',bottom_part3, 'bottom_part31',bottom_part31, ...
   'down_1', down_1, 'down_11', down_11, ...
   'down_2', down_2, 'down_21', down_21, ...
   'up_1', up_1, 'up_11', up_11, ...
   'up_2', up_2, 'up_21', up_21, ...
   'roof_part1',roof_part1, 'roof_part11',roof_part11, ...
   'roof_part2',roof_part2, 'roof_part21',roof_part21, ...
   'roof_part3',roof_part3, 'roof_part31',roof_part31, ...
   'out',out, 'out1',out1, ...
   'pipeline_left1',pipeline_left1, ...
   'pipeline_left2',pipeline_left2, ...
   'pipeline_m1',pipeline_m1, ...
   'pipeline_m2',pipeline_m2, ...
   'pipeline_right1',pipeline_right1, ...
   'pipeline_right2',pipeline_right2, ...
   'pump',pump, ...
   'X_t1', X_t1, ...
   'Y_t', Y_t, ...
   'X_t2', X_t2, ...
   'X_t3', X_t3, ...
   'Y_t3', Y_t3, ...
   'X_t4', X_t4);
