%
% obnova statickzch objektov
% Tatiana Lipnicanova
% marec 2004
%
function draw_background(phase)
% thi function is called by animation.m and tanks.m

color_water = [0.62 0.753 0.922];
color_pipeline = [0.93 0.93 0.93];
bg = background;
num = strcmp(phase,'begin');

% if num == 1 | num == 0
    % color of the left pipeline
    h_fill = fill([bg.pipeline_left1(6:12,1); flipud(bg.pipeline_left2(6:12,1))], ...
        [bg.pipeline_left1(6:12,2); flipud(bg.pipeline_left2(6:12,2))], ...
        color_pipeline, 'EdgeColor', 'none' );
    h_fill = fill([bg.pump(2,1); bg.pipeline_left1(2:6,1); flipud(bg.pipeline_left2(1:6,1))], ...
        [bg.pump(2,2); bg.pipeline_left1(2:6,2); flipud(bg.pipeline_left2(2:6,2)); bg.pump(2,2)], ...
        color_pipeline, 'EdgeColor', 'none' );
    h_fill = fill([bg.pipeline_left1(1,1); bg.pipeline_left1(1,1); bg.pipeline_left2(1,1); bg.pipeline_left2(1,1)], ...
        [bg.bottom_tank(3,2); bg.pump(7,2); bg.pump(6,2); bg.bottom_tank(3,2)], ...
        color_pipeline, 'EdgeColor', 'none' );
    
    % color of the middle pipeline
    h_fill = fill([bg.pipeline_m1(:,1); flipud(bg.pipeline_m2(:,1))], ...
        [bg.pipeline_m1(:,2); flipud(bg.pipeline_m2(:,2))], ...
        color_pipeline, 'EdgeColor', 'none', 'EraseMode', 'background');
    % color of the right pipeline
    h_fill = fill([bg.pipeline_right1(:,1); flipud(bg.pipeline_right2(:,1))], ...
        [bg.pipeline_right1(:,2); flipud(bg.pipeline_right2(:,2))], ...
        color_pipeline, 'EdgeColor', 'none', 'EraseMode', 'background');
        h_plot = plot(bg.right_side(:,1) , bg.right_side(:,2), bg.right_side1(:,1) , bg.right_side1(:,2), ...
        'Color', [0 0 0], 'EraseMode', 'background');
    
    h_plot = plot(bg.out(:,1) , bg.out(:,2), bg.out1(:,1) , bg.out1(:,2), ...
        'Color', [0 0 0], 'EraseMode', 'background');
    h_plot = plot(bg.pipeline_left1(:,1) , bg.pipeline_left1(:,2), ...
        'Color', [0 0 0], 'EraseMode', 'background');
    h_plot = plot(bg.pipeline_left2(:,1) , bg.pipeline_left2(:,2), ...
        'Color', [0 0 0], 'EraseMode', 'background');
    h_plot = plot(bg.pipeline_m1(:,1) , bg.pipeline_m1(:,2), ...
        'Color', [0 0 0], 'EraseMode', 'background');
    h_plot = plot(bg.pipeline_m2(:,1) , bg.pipeline_m2(:,2), ...
        'Color', [0 0 0], 'EraseMode', 'background');
    h_plot = plot(bg.pipeline_right1(:,1) , bg.pipeline_right1(:,2), ...
        'Color', [0 0 0], 'EraseMode', 'background');
    h_plot = plot(bg.pipeline_right2(:,1) , bg.pipeline_right2(:,2), ...
        'Color', [0 0 0], 'EraseMode', 'background');
    h_plot = plot(bg.left_side(:,1) , bg.left_side(:,2), bg.left_side1(:,1) , bg.left_side1(:,2), ...
        'Color', [0 0 0], 'EraseMode', 'background');

% end
if num == 1

    % water in the lower big tank
    h_fill = fill(bg.bottom_tank([3,6,5,4,3],1), ...
        bg.bottom_tank([3,6,5,4,3],2), ...
        color_water, 'EdgeColor', 'none');
    
    % color of the lower big tank
    h_fill = fill(bg.bottom_tank(:,1), ...
        bg.bottom_tank(:,2), ...
        color_pipeline, 'EdgeColor', 'none');
    
    % color of the pump
    h_fill = fill(bg.pump(:,1), bg.pump(:,2), 0.1*[1 1 1]);
    h_plot = plot(bg.pump(:,1) , bg.pump(:,2), ...
        'Color', [0 0 0]);
    
    % clear the old objects (patch), which are created by fill function
    if size(h_fill,1) > 8
        delete(h_fill(9:(size(h_fill,1))))
    end
    
    % draw the background
    h_plot = plot(bg.bottom_tank(:,1), bg.bottom_tank(:,2), ...
        'Color', 0.4*[1 1 1]);
    h_plot = plot(bg.bottom_part1(:,1) , bg.bottom_part1(:,2), bg.bottom_part11(:,1) , bg.bottom_part11(:,2), ...
        'Color', [0 0 0]);
    h_plot = plot(bg.bottom_part2(:,1) , bg.bottom_part2(:,2), bg.bottom_part21(:,1) , bg.bottom_part21(:,2), ...
        'Color', [0 0 0]);
    h_plot = plot(bg.bottom_part3(:,1) , bg.bottom_part3(:,2), bg.bottom_part31(:,1) , bg.bottom_part31(:,2), ...
        'Color', [0.5 0.5 0.5]);
    h_plot = plot(bg.bottom_part4(:,1) , bg.bottom_part4(:,2), bg.bottom_part41(:,1) , bg.bottom_part41(:,2), ...
        'Color', [0.5 0.5 0.5]);
    h_plot = plot(bg.down_1(:,1) , bg.down_1(:,2), bg.down_11(:,1) , bg.down_11(:,2), ...
        'Color', [0 0 0]);
    h_plot = plot(bg.down_2(:,1) , bg.down_2(:,2), bg.down_21(:,1) , bg.down_21(:,2), ...
        'Color', [0.5 0.5 0.5]);
    h_plot = plot(bg.up_1(:,1) , bg.up_1(:,2), bg.up_11(:,1) , bg.up_11(:,2), ...
        'Color', [0 0 0]);
    h_plot = plot(bg.up_2(:,1) , bg.up_2(:,2), bg.up_21(:,1) , bg.up_21(:,2), ...
        'Color', [0.5 0.5 0.5]);
    h_plot = plot(bg.top_part1(:,1) , bg.top_part1(:,2), bg.top_part11(:,1) , bg.top_part11(:,2), ...
        'Color', [0 0 0]);
    h_plot = plot(bg.top_part2(:,1) , bg.top_part2(:,2), bg.top_part21(:,1) , bg.top_part21(:,2), ...
        'Color', [0 0 0]);
    h_plot = plot(bg.top_part3(:,1) , bg.top_part3(:,2), bg.top_part31(:,1) , bg.top_part31(:,2), ...
        'Color', [0.5 0.5 0.5]);
    h_plot = plot(bg.top_part4(:,1) , bg.top_part4(:,2), bg.top_part41(:,1) , bg.top_part41(:,2), ...
        'Color', [0.5 0.5 0.5]);
    h_plot = plot(bg.roof_part1(:,1) , bg.roof_part1(:,2), bg.roof_part11(:,1) , bg.roof_part11(:,2), ...
        'Color', [0 0 0]);
    h_plot = plot(bg.roof_part2(:,1) , bg.roof_part2(:,2), bg.roof_part21(:,1) , bg.roof_part21(:,2), ...
        'Color', [0 0 0]);
    h_plot = plot(bg.roof_part3(:,1) , bg.roof_part3(:,2), bg.roof_part31(:,1) , bg.roof_part31(:,2), ...
        'Color', [0 0 0]);
    
    % clear the old objects (lines), which are created by plot function
    if size(h_plot,1) > 26
        delete(h_plot(27:(size(h_plot,1))))
    end
end